import * as Koa from 'koa'

declare module 'koa' {
  interface User {
    uuid: string
    name: string
    github?: string
    youtube?: string
    twitch?: string
    points: number
  }

  interface Session {
    id: string
    maxAge: number
    user?: User
    isLoggedIn: boolean
    identifier: string
    [key: string]: any
  }

  interface Context {
    session: Session
  }
}

declare module '@sr-net/session-middleware' {
  interface IOptions {
    url?: string
    domain?: string
  }

  export function Session(options: IOptions): Koa.Middleware
}
